/***********************************************************************
 Name             : header.java
 Autor            : Marcel Lattmann
                    Eidgenoessisch Technische Hochschule Zuerich (ETHZ)
 Letzte Aenderung : 3.8.1999

 Eingabe der Header-Daten wie Titel oder Versuchsperson.
 
 Benoetigt folgende Klassen:

	
 History:
************************************************************************/

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Header extends Dialog implements ActionListener {

  public static final int NRITEMS = 8;

  private String[] feldTitel={"Titel","Pilz","Stmme","Referenzstmme","Test-Fungizide","Versuchsvariante","Versuchsperson","Bemerkungen"};
  private TextArea ta[] = new TextArea[8];
  private TextField tf[] = new TextField[8];
  private String str[] = new String[10];  

  private int[] yPos={0,2,4,6,8,10,12,14};
  private int[] height={1,1,1,1,1,1,1,3};
  private int[] rows={1,1,1,1,1,1,1,3};
  private Button ok, cancel;
  String newln;

  public Header(Frame parent, String[] info, Font defaultFont, Color background) {
    /* Erzeuge einen blockierenden Dialog */
    super(parent,"Headerdaten",true);

    /* Wird neu im aufrufenden Programm gemacht.
     * f = new Frame(); 
     * f.setResizable(true);
     * f.setSize(700,600);
     *
     * f.setBackground(background);
     */

    this.setBackground(background);

    // Set line termination character
    newln = System.getProperty("line.separator");

    GridBagConstraints c = new GridBagConstraints();
    GridBagLayout gb = new GridBagLayout();
    this.setLayout(gb);
    c.insets = new Insets(5,5,5,5);

    for (int i = 0; i < NRITEMS; i++) {
      str[i]=info[i];   // speichern fuer spaeter
  
      Label l1 = new Label(feldTitel[i]);
      c.gridx = 0; c.gridy = yPos[i];
      c.gridwidth  = 3;
      c.gridheight = height[i];
      c.weightx = 0.0; c.weighty = 0.0;
      c.fill = GridBagConstraints.NONE;
      c.anchor = GridBagConstraints.NORTHWEST;
      this.add(l1,c);

      c.gridx = 3; c.gridy = yPos[i];
      c.gridwidth  = 17;
      c.gridheight = height[i];
      c.weightx = 0.0; c.weighty = 0.0;
      c.fill = GridBagConstraints.NONE;
      c.anchor = GridBagConstraints.NORTHWEST;

      if (rows[i]==1) {
        tf[i] = new TextField(info[i],60);
        tf[i].setBackground(background);
        tf[i].setFont(defaultFont);
        this.add(tf[i],c);
      } else {
        ta[i] = new TextArea(info[i], rows[i],60, TextArea.SCROLLBARS_NONE);
        ta[i].setBackground(background);
        ta[i].setFont(defaultFont);
        this.add(ta[i],c);
      }
    };

    ok = new Button("ok");
    ok.addActionListener(this);
    ok.setBackground(background);

    c.gridx = 0; c.gridy = 20;
    c.gridwidth  = 10;
    c.gridheight = 2;
    c.weightx = 0.0; c.weighty = 0.0;
    c.fill = GridBagConstraints.NONE;
    c.anchor = GridBagConstraints.CENTER;
    this.add(ok,c);

    cancel = new Button("cancel");
    cancel.addActionListener(this);
    cancel.setBackground(background);

    c.gridx = 10; c.gridy = 20;
    c.gridwidth  = GridBagConstraints.REMAINDER;
    c.gridheight = 2;
    c.weightx = 0.0; c.weighty = 0.0;
    c.fill = GridBagConstraints.NONE;
    c.anchor = GridBagConstraints.CENTER;
    this.add(cancel,c);

    // Finally, set the dialog to its preferred size.
    this.pack();
  }

  public String[] getData() {
    return str;
  }

  public void actionPerformed(ActionEvent e) {
    int i,l;
    Header.this.dispose();   // pop down dialog
    Button s = (Button)e.getSource();
    if (s== ok) {
      for (i = 0; i < NRITEMS-1; i++) {
        if (rows[i] ==1)
          str[i]=tf[i].getText(); 
        else
          str[i]=ta[i].getText(); 
      }

      for (i = 0; i < 3; i++) 
        str[i+NRITEMS-1]="";
      StringTokenizer t = new StringTokenizer(ta[NRITEMS-1].getText(), newln);
      int num_lines = t.countTokens();
      for(i = 0; i < num_lines; i++)
        str[i+NRITEMS-1] = t.nextToken();
      
      for (i=0;i<NRITEMS+2;i++) {
        if (str[i].length() > 60) {
          str[i]=str[i].substring(0,59);
        }
      }
    }
  }
}
